package my.mystore.business;

import my.mystore.business.Item;

/**
 * @author Ryu Fukushima
 * @version 1.0
 * @created 11-2-2006 00:15:22
 */
public class BillCalculator {

    public Item currentSale;

    public BillCalculator() {

    }

    public void finalize() throws Throwable {

    }

    public int calcItemTotal() {
        return 0;
    }

    /**
     * 
     * @param member
     * @param campaign
     * @return
     */
    public int calcBill(boolean member, boolean campaign) {
        int total = 0; // ܂̏i
        double rate = 0; // 
        int carriage = 0; // 

        total = calcItemTotal();

        // vZ
        // 2,000~(lO)ȏ́A
        if (total < 2000) {
            // 2,000~(lO)܂ł͑300~
            carriage = 300;
        }

        // ߂
        rate = getDiscountRate(total, member, campaign);

        // źA_ȉ͐؂グ
        Double payment = new Double(Math.ceil(total * rate));

        return payment.intValue() + carriage;
    }

    /**
     * zvZ
     * 
     * @param total
     * @param member
     * @param campaign
     * 
     */
    public double getDiscountRate(int total, boolean campaign, boolean member) {

        // 1300~𒴂Ăꍇ̓G[Ƃ
        if (total < 1 || 3000000 < total) {
            throw new IllegalArgumentException("1300~𒴂Ă");
        }

        // total < 1000 ŉłȂLy[ԂłȂƂ͒lȂ
        if (total < 1000 && true != campaign && true != member) {
            return 0;
        }

        // 
        double rate = 0;

        if (true == campaign) {
            // Ly[Ԃ̂Ƃ
            // ʏ̒lAD悵Ċs
            if (total < 1000) {
                // 1,000~܂ł͑5%̒l
                rate = 0.05;
            } else if (1000 <= total && total < 100000) {
                // 1,000~ȏA100,000~͑10%̒l
                rate = 0.1;
            } else {
                // 100,000~ȏ͑15%̒l
                rate = 0.15;
            }
        } else if (true == member) {
            // ̂Ƃ
            if (total < 1000) {
                // 1,000~܂ł͑2%̒l
                rate = 0.02;
            } else if (1000 <= total && total < 100000) {
                // 1,000~ȏA100,000~͑5%̒l
                rate = 0.05;
            } else {
                // 100,000~ȏ͑10%̒l
                rate = 0.10;
            }
        } else {
            // ʏ̒l 1,000~܂ł͒lȂ
            if (1000 <= total && total < 100000) {
                // 1,000~ȏA100,000~͑2%̒l
                rate = 0.02;
            } else {
                // 100,000~ȏ͑15%̒l
                rate = 0.05;
            }
        }

        return rate;
    }

    /**
     * @param item
     * 
     */
    public void putItem(Item item) {

    }

}