package my4.mystore.business;

import org.junit.Test;
import static org.junit.Assert.*;
import junit.framework.JUnit4TestAdapter;

public class BillCalculatorStep1Test  {

    // v 1000
    // Ly[ false
    // / true
    // ҂錋 l 2%
    @Test
    public void testGetDiscountRateCase07() {
        BillCalculator billcalc = new BillCalculator();
        double actual = billcalc.getDiscountRate(1000, false, true);
        double expected = 0.05;
        
        assertEquals("eXgP[X 07", expected, actual, 0.001);
    }

    // v 3000000
    // Ly[ true
    // / false
    // ҂錋 l 5%
    @Test
    public void testGetDiscountRateCase45() {
        BillCalculator billcalc = new BillCalculator();
        double actual = billcalc.getDiscountRate(3000000, true, false);
        double expected = 0.15;
        
        assertEquals("eXgP[X 45", expected, actual, 0.001);
    }
    
    // ̃\bhJUnit3.x̃eXgi[Nł
    public static junit.framework.Test suite() {
        return new JUnit4TestAdapter(BillCalculatorStep1Test.class);
    }
}
