package my4.mystore.business;

import org.junit.Test;
import org.junit.Before;
import static org.junit.Assert.*;
import junit.framework.JUnit4TestAdapter;

// eXg\bht@N^O
// 1. ʂɗpł鏉 setUp() Ɉڂ
// 2. ʂ̌㏈tearDown()ŋLq
// 3. eXg\bh𕪊
// 4. eXg\bh𓝍
//
// BillCalculatorStep2Test
// 1, 3{

public class BillCalculatorStep3Test {

    private BillCalculator billcalc = null;

    private double actual = 0;

    @Before
    public void setUp() {
        billcalc = new BillCalculator();
        actual = 0;
    }

    // G[eXg
    @Test
    public void testGetDiscountRateCaseError() {
        try {
            billcalc.getDiscountRate(Integer.MAX_VALUE, false, false);
            fail("ől̃`FbNɖ肪܂B");
        } catch (IllegalArgumentException e) {
            assertTrue("őlɂ鋭G[eXg", true);
        }

        try {
            billcalc.getDiscountRate(Integer.MIN_VALUE, false, false);
            fail("ŏl̃`FbNɖ肪܂B");
        } catch (IllegalArgumentException e) {
            assertTrue("ŏlɂ鋭G[eXg", true);
        }
    }

    // ̏ꍇ: n P[X04  P[X14
    // P[X 4 1 false false 0
    // P[X 5 500 false false 0
    // P[X 6 999 false false 0
    // P[X 7 1000 false false 2%
    // P[X 8 1001 false false 2%
    // P[X 9 50000 false false 2%
    // P[X 10 99999 false false 2%
    // P[X 11 100000 false false 5%
    // P[X 12 100001 false false 5%
    // P[X 13 2999999 false false 5%
    // P[X 14 3000000 false false 5%

    @Test
    public void testGetDiscountRateNotMember04() {
        actual = billcalc.getDiscountRate(1, false, false);
        assertEquals("eXgP[X 04", 0, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateNotMember05() {
        actual = billcalc.getDiscountRate(500, false, false);
        assertEquals("eXgP[X 05", 0, actual, 0.001);
    }
    
    @Test
    public void testGetDiscountRateNotMember06() {
        actual = billcalc.getDiscountRate(999, false, false);
        assertEquals("eXgP[X 06", 0, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateNotMember07() {
        actual = billcalc.getDiscountRate(1000, false, false);
        assertEquals("eXgP[X 07", 0.02, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateNotMember08() {
        actual = billcalc.getDiscountRate(1001, false, false);
        assertEquals("eXgP[X 08", 0.02, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateNotMember09() {
        actual = billcalc.getDiscountRate(50000, false, false);
        assertEquals("eXgP[X 09", 0.02, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateNotMember10() {
        actual = billcalc.getDiscountRate(99999, false, false);
        assertEquals("eXgP[X 10", 0.02, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateNotMember11() {
        actual = billcalc.getDiscountRate(100000, false, false);
        assertEquals("eXgP[X 11", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateNotMember12() {
        actual = billcalc.getDiscountRate(100001, false, false);
        assertEquals("eXgP[X 12", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateNotMember13() {
        actual = billcalc.getDiscountRate(2999999, false, false);
        assertEquals("eXgP[X 13", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateNotMember14() {
        actual = billcalc.getDiscountRate(3000000, false, false);
        assertEquals("eXgP[X 14", 0.05, actual, 0.001);
    }

    // ̏ꍇ: ُn P[X01  P[X03AP[X15AP[X16
    // P[X 1 -1000 false false G[
    // P[X 2 -1 false false G[
    // P[X 3 0 false false G[
    // P[X 15 3000001 false false G[
    // P[X 16 5000000 false false G[
    @Test
    public void testGetDiscountRateNotMemberError() {
        try {
            billcalc.getDiscountRate(-1000, false, false);
            fail("eXgP[X01:(-1000)̃`FbNɖ肪܂B");
        } catch (IllegalArgumentException e) {
            assertTrue("̃`FbN̓pX܂B", true);
        }
        try {
            billcalc.getDiscountRate(-1, false, false);
            fail("eXgP[X02:(-1)̃`FbNɖ肪܂B");
        } catch (IllegalArgumentException e) {
            assertTrue("̃`FbN̓pX܂B", true);
        }
        try {
            billcalc.getDiscountRate(0, false, false);
            fail("eXgP[X03:(0)̃`FbNɖ肪܂B");
        } catch (IllegalArgumentException e) {
            assertTrue("̃`FbN̓pX܂B", true);
        }
        try {
            billcalc.getDiscountRate(3000001, false, false);
            fail("eXgP[X15:(3000001)̃`FbNɖ肪܂B");
        } catch (IllegalArgumentException e) {
            assertTrue("̃`FbN̓pX܂B", true);
        }
        try {
            billcalc.getDiscountRate(5000000, false, false);
            fail("eXgP[X16:(5000000)̃`FbNɖ肪܂B");
        } catch (IllegalArgumentException e) {
            assertTrue("̃`FbN̓pX܂B", true);
        }
    }

    // ̏ꍇ: eXgP[X20  30
    // P[X 20 1 false true 2%
    // P[X 21 500 false true 2%
    // P[X 22 999 false true 2%
    // P[X 23 1000 false true 5%
    // P[X 24 1001 false true 5%
    // P[X 25 50000 false true 5%
    // P[X 26 99999 false true 5%
    // P[X 27 100000 false true 10%
    // P[X 28 100001 false true 10%
    // P[X 29 2999999 false true 10%
    // P[X 30 3000000 false true 10%
    @Test
    public void testGetDiscountRateMember20() {
        actual = billcalc.getDiscountRate(1, false, true);
        assertEquals("eXgP[X 20", 0.02, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign21() {
        actual = billcalc.getDiscountRate(500, false, true);
        assertEquals("eXgP[X 21", 0.02, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign22() {
        actual = billcalc.getDiscountRate(999, false, true);
        assertEquals("eXgP[X 22", 0.02, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign23() {
        actual = billcalc.getDiscountRate(1000, false, true);
        assertEquals("eXgP[X 23", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign24() {
        actual = billcalc.getDiscountRate(1001, false, true);
        assertEquals("eXgP[X 24", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign25() {
        actual = billcalc.getDiscountRate(50000, false, true);
        assertEquals("eXgP[X 25", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign26() {
        actual = billcalc.getDiscountRate(99999, false, true);
        assertEquals("eXgP[X 26", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign27() {
        actual = billcalc.getDiscountRate(100000, false, true);
        assertEquals("eXgP[X 27", 0.10, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign28() {
        actual = billcalc.getDiscountRate(100001, false, true);
        assertEquals("eXgP[X 28", 0.10, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign29() {
        actual = billcalc.getDiscountRate(2999999, false, true);
        assertEquals("eXgP[X 29", 0.10, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign30() {
        actual = billcalc.getDiscountRate(3000000, false, true);
        assertEquals("eXgP[X 30", 0.10, actual, 0.001);
    }

    // eXgP[X3646
    // Ly[ true
    // / true
    // P[X 36 1 true true 5%
    // P[X 37 500 true true 5%
    // P[X 38 999 true true 5%
    // P[X 39 1000 true true 10%
    // P[X 40 1001 true true 10%
    // P[X 41 50000 true true 10%
    // P[X 42 99999 true true 10%
    // P[X 43 100000 true true 15%
    // P[X 44 100001 true true 15%
    // P[X 45 2999999 true true 15%
    // P[X 46 3000000 true true 15%
    @Test
    public void testGetDiscountRateCampaign36() {
        actual = billcalc.getDiscountRate(1, true, true);
        assertEquals("eXgP[X 36", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign37() {
        actual = billcalc.getDiscountRate(500, true, true);
        assertEquals("eXgP[X 37", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign38() {
        actual = billcalc.getDiscountRate(999, true, true);
        assertEquals("eXgP[X 38", 0.05, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign39() {
        actual = billcalc.getDiscountRate(1000, true, true);
        assertEquals("eXgP[X 39", 0.1, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign40() {
        actual = billcalc.getDiscountRate(1001, true, true);
        assertEquals("eXgP[X 40", 0.1, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign41() {
        actual = billcalc.getDiscountRate(50000, true, true);
        assertEquals("eXgP[X 41", 0.1, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign42() {
        actual = billcalc.getDiscountRate(99999, true, true);
        assertEquals("eXgP[X 42", 0.1, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign43() {
        actual = billcalc.getDiscountRate(100000, true, true);
        assertEquals("eXgP[X 43", 0.15, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign44() {
        actual = billcalc.getDiscountRate(100001, true, true);
        assertEquals("eXgP[X 44", 0.15, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign45() {
        actual = billcalc.getDiscountRate(2999999, true, true);
        assertEquals("eXgP[X 45", 0.15, actual, 0.001);
    }

    @Test
    public void testGetDiscountRateCampaign46() {
        actual = billcalc.getDiscountRate(3000000, true, true);
        assertEquals("eXgP[X 46", 0.15, actual, 0.001);
    }
    
    // ̃\bhJUnit3.x̃eXgi[Nł
    public static junit.framework.Test suite() {
        return new JUnit4TestAdapter(BillCalculatorStep3Test.class);
    }
}
